com.pixelmed.dicom

## Class DicomDirectoryBrowser

- java.lang.Object
- - com.pixelmed.dicom.DicomDirectoryBrowser

-     public class DicomDirectoryBrowser
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DicomDirectoryBrowser(AttributeList list, java.lang.String parentFilePath)`
    `DicomDirectoryBrowser(AttributeList list, java.lang.String parentFilePath, javax.swing.JFrame frame)`
    `DicomDirectoryBrowser(AttributeList list, java.lang.String parentFilePath, javax.swing.JScrollPane treeBrowserScrollPane, javax.swing.JScrollPane attributeBrowserScrollPane)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.awt.event.MouseListener` | `buildMouseListenerToDetectDoubleClickEvents()`
    `protected javax.swing.event.TreeSelectionListener` | `buildTreeSelectionListenerToDisplayAttributesOfSelectedRecord(javax.swing.JScrollPane attributeBrowserScrollPane)`
    `protected javax.swing.event.TreeSelectionListener` | `buildTreeSelectionListenerToDoSomethingWithSelectedFiles(java.lang.String parentFilePath)`
    `protected java.util.HashSet<AttributeTag>` | `chooseExcludeList(DicomDirectoryRecord dirRecord)`
    `protected void` | `createExcludeLists()`
    `protected void` | `doSomethingMoreWithWhateverWasSelected()`
    `protected void` | `doSomethingWithSelectedFiles(java.util.Vector paths)`
    `DicomDirectory` | `getDicomDirectory()` Get this directory, initializing any structures necessary.
    `java.lang.String` | `getParentFilePath()`
    `static void` | `main(java.lang.String[] arg)`
    `protected void` | `setFont(java.awt.Font font)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DicomDirectoryBrowser

          public DicomDirectoryBrowser(AttributeList list,
                                       java.lang.String parentFilePath)
                                throws DicomException

      Parameters:
        `list` - a list of attributes describing a DICOMDIR instance
        `parentFilePath` - the path to which all ReferencedFileIDs in the DICOMDIR are relative (i.e., the folder in which the DICONDIR is/will be stored)
      Throws:
        `DicomException` - if error in DICOM encoding

    - #### DicomDirectoryBrowser

          public DicomDirectoryBrowser(AttributeList list,
                                       java.lang.String parentFilePath,
                                       javax.swing.JScrollPane treeBrowserScrollPane,
                                       javax.swing.JScrollPane attributeBrowserScrollPane)
                                throws DicomException

      Parameters:
        `list` - a list of attributes describing a DICOMDIR instance
        `parentFilePath` - the path to which all ReferencedFileIDs in the DICOMDIR are relative (i.e., the folder in which the DICONDIR is/will be stored)
        `treeBrowserScrollPane` - where to put the tree browser for the directory
        `attributeBrowserScrollPane` - where to put the attribute browser for a selected record
      Throws:
        `DicomException` - if error in DICOM encoding

    - #### DicomDirectoryBrowser

          public DicomDirectoryBrowser(AttributeList list,
                                       java.lang.String parentFilePath,
                                       javax.swing.JFrame frame)
                                throws DicomException

      Parameters:
        `list` - a list of attributes describing a DICOMDIR instance
        `parentFilePath` - the path to which all ReferencedFileIDs in the DICOMDIR are relative (i.e., the folder in which the DICONDIR is/will be stored)
        `frame` - where to put the browsers
      Throws:
        `DicomException` - if error in DICOM encoding

  - ### Method Detail

    - #### setFont

          protected void setFont(java.awt.Font font)

      Parameters:
        `font` - font to use

    - #### buildTreeSelectionListenerToDoSomethingWithSelectedFiles

          protected javax.swing.event.TreeSelectionListener buildTreeSelectionListenerToDoSomethingWithSelectedFiles(java.lang.String parentFilePath)

      Parameters:
        `parentFilePath` - parent directory at which DICOMDIR file paths are rooted
      Returns:
        a TreeSelectionListener

    - #### buildTreeSelectionListenerToDisplayAttributesOfSelectedRecord

          protected javax.swing.event.TreeSelectionListener buildTreeSelectionListenerToDisplayAttributesOfSelectedRecord(javax.swing.JScrollPane attributeBrowserScrollPane)

      Parameters:
        `attributeBrowserScrollPane` - where to display the attributes of the selected record
      Returns:
        a TreeSelectionListener

    - #### buildMouseListenerToDetectDoubleClickEvents

          protected java.awt.event.MouseListener buildMouseListenerToDetectDoubleClickEvents()

      Returns:
        a MouseListener to detect double click events

    - #### chooseExcludeList

          protected java.util.HashSet<AttributeTag> chooseExcludeList(DicomDirectoryRecord dirRecord)

      Parameters:
        `dirRecord` - the directory record for which we need to select an exclude list based on its DirectoryRecordType
      Returns:
        the appropriate list of attributes to exclude from display based on DirectoryRecordType, or the defaultExcludeList if DirectoryRecordType unrecognized

    - #### createExcludeLists

          protected void createExcludeLists()

    - #### getDicomDirectory

          public DicomDirectory getDicomDirectory()

      Get this directory, initializing any structures necessary.

      Returns:
        this directory

    - #### getParentFilePath

          public java.lang.String getParentFilePath()

      Returns:
        the parent file path

    - #### doSomethingWithSelectedFiles

          protected void doSomethingWithSelectedFiles(java.util.Vector paths)

      Parameters:
        `paths` - the file paths selected

    - #### doSomethingMoreWithWhateverWasSelected

          protected void doSomethingMoreWithWhateverWasSelected()

    - #### main

          public static void main(java.lang.String[] arg)

      Parameters:
        `arg` - a DICOMDIR file